VAR
  long speed_Data, pwm_Data[24], stack[10]

PUB start : i
  buffer_address := @pwm_Data
  speed_address := @speed_Data
  speed_Data := %100000
  cognew(@asm_entry, @stack[0])

PUB speed_set(data)
  if data > 6
    data := 6
  speed_Data := 1 << (data+9)

PUB buffer_set(data)
  pwm_Data[data>>8] := data & $7F

DAT
                        org
asm_entry
                        mov     dira,all_high
                        andn    outa,all_high
                        rdlong  counter1,speed_address
                        mov     counter2,#0
:start_entry
                        sub     counter1,#1             wz
              if_nz     jmp     #:start_entry
                        rdlong  counter1,speed_address
                        add     counter2,#1
                        and     counter2,#%01111111
                        mov     work_bit,#0
:bit_loop
                        mov     bit_mask,#1
                        shl     bit_mask,work_bit
                        mov     t1,work_bit
                        shl     t1,#2
                        add     t1,buffer_address
                        rdlong  pwm_value,t1            wz
              if_z      jmp     #:led_off
                        cmp     pwm_value,counter2      wz
              if_z      jmp     #:led_on
                        cmp     pwm_value,counter2      wc
              if_c      jmp     #:led_off
:led_on
                        or      outa,bit_mask
                        jmp     #:next_bit
:led_off
                        andn    outa,bit_mask
:next_bit
                        add     work_bit,#1
                        cmp     work_bit,#24            wz
              if_nz     jmp     #:bit_loop
                        jmp     #:start_entry

all_high                long    %00000000111111111111111111111111
buffer_address          long    0
counter1                long    0
counter2                long    0
speed_address           long    0
work_bit                long    0
bit_mask                long    0
pwm_value               long    0
t1                      long    0

                        fit

